/* ORIGINAL_SCCSID: 		Sccsid @(#) oserror.h 1.1 9/20/93  */
/*		Sccsid %Z% %M% %I% %G% */

/*
**		Sybase Server-Library
**		Confidential Property of Sybase, Inc.
**		(c) Copyright Sybase, Inc. 1992 - 1993
**		All rights reserved
**
** oserror.h	This header file contains all required definitions 
**		for Open Server error handling.
*/
#if	!defined(__OSERROR_H__)
#define __OSERROR_H__

/*
**  Error severity
*/
#define	SRV_INFO		(CS_BYTE)10
#define	SRV_FATAL_PROCESS	(CS_BYTE)15
#define	SRV_FATAL_SERVER	(CS_BYTE)20

/*
**  Error returns, SRV_CONTINUE is defined in ospublic.h
*/
#define	SRV_CANCEL		(CS_INT)1
#define	SRV_EXIT_PROGRAM	(CS_INT)2

/*
** This define denotes that no operating-system error occurred.
*/
#define	SRV_ENO_OS_ERR		-1

/*
** Add a define which denotes that a netlib error occurred.
*/
#define	SRV_E_NETERR		-2

/*
** Special error numbers, taken from SQL-Server, for environment changes.
** The client expects these rather than the Open Server error numbers
*/
#define	SQLSRV_ENVDB	5701	/* instead of SRV_EENVDB		*/
#define	SQLSRV_ENVLANG	5703	/* instead of SRV_EENVLANG		*/
#define	SQLSRV_ENVCHAR	5704	/* instead of SRV_EENVCHAR		*/

/*
** The maximum error number used by the SQL Server or Client libraries.
** Clients should define their Open Server errors as numbers greater than
** SRV_MAXERROR
*/
#define SRV_MAXERROR            (CS_INT)20000


/*
** OpenServer error numbers
*/
#define	SRV_EMINERR		16000
#define	SRV_EOPTION		0 + SRV_EMINERR
#define	SRV_ENOPROC		1 + SRV_EMINERR
#define	SRV_ELIVEPROC		2 + SRV_EMINERR
#define	SRV_ENOEVENT		3 + SRV_EMINERR
#define	SRV_EBADEVENT		4 + SRV_EMINERR
#define	SRV_EBADUEVENT		5 + SRV_EMINERR
#define	SRV_EIOBADBUF		6 + SRV_EMINERR
#define	SRV_EIOBADTYPE		7 + SRV_EMINERR
#define	SRV_EMEMORY		8 + SRV_EMINERR
#define	SRV_ENOPPROC		9 + SRV_EMINERR
#define	SRV_EINITNET		10 + SRV_EMINERR
#define	SRV_EIFILE		11 + SRV_EMINERR
#define	SRV_EFOPEN		12 + SRV_EMINERR
#define	SRV_ESRVNAME		13 + SRV_EMINERR
#define	SRV_EHOMEDIR		14 + SRV_EMINERR
#define	SRV_EPROCTYPE		15 + SRV_EMINERR
#define	SRV_ENOMSGS		16 + SRV_EMINERR
#define	SRV_EMSGPROC		17 + SRV_EMINERR
#define	SRV_EMSGADDRESS		18 + SRV_EMINERR
#define	SRV_EMSGTYPE		19 + SRV_EMINERR
#define	SRV_EBADIOEVENT		20 + SRV_EMINERR
#define	SRV_EIOERROR		21 + SRV_EMINERR
#define	SRV_EQPROC		22 + SRV_EMINERR
#define	SRV_EQFREE		23 + SRV_EMINERR
#define	SRV_ESRVEVENT		24 + SRV_EMINERR
#define	SRV_ECLNTMSG		25 + SRV_EMINERR
#define	SRV_ESOCKET		26 + SRV_EMINERR
#define	SRV_EBIND		27 + SRV_EMINERR
#define	SRV_EGETHOST		28 + SRV_EMINERR
#define	SRV_ELISTEN		29 + SRV_EMINERR
#define	SRV_ECNTSOCKET		30 + SRV_EMINERR
#define	SRV_EPROCDEAD		31 + SRV_EMINERR
#define	SRV_EBADINDEX		32 + SRV_EMINERR
#define	SRV_ENOCONVERT		33 + SRV_EMINERR
#define	SRV_EMAXNAME		34 + SRV_EMINERR
#define SRV_ECUFLOW		35 + SRV_EMINERR
#define SRV_ECOFLOW		36 + SRV_EMINERR
#define SRV_ECBINOFLOW		37 + SRV_EMINERR
#define SRV_ECPREC		38 + SRV_EMINERR
#define SRV_ECSYNTAX		39 + SRV_EMINERR
#define SRV_EBADLEN		40 + SRV_EMINERR
#define SRV_EUVDT		41 + SRV_EMINERR
#define SRV_EUFDT		42 + SRV_EMINERR
#define SRV_ENOROWDESC		43 + SRV_EMINERR
#define SRV_ENOTYPE		44 + SRV_EMINERR
#define SRV_ENOITEM		45 + SRV_EMINERR
#define SRV_ESTATSTATE		46 + SRV_EMINERR
#define SRV_ENOTRACE		47 + SRV_EMINERR
#define SRV_ENORPC		48 + SRV_EMINERR
#define SRV_ENOITEMNO		49 + SRV_EMINERR
#define SRV_ENORETPARAM		50 + SRV_EMINERR
#define SRV_EBADPARAMLEN	51 + SRV_EMINERR
#define SRV_EBADPARAMMAXLEN	52 + SRV_EMINERR
#define SRV_ESYMBOL		53 + SRV_EMINERR
#define SRV_ESRVTYPE		54 + SRV_EMINERR
#define	SRV_ESRVPROCTYPE	55 + SRV_EMINERR
#define SRV_ENULLPTR		56 + SRV_EMINERR
#define SRV_ETDSVERSION		57 + SRV_EMINERR
#define SRV_EOOB		58 + SRV_EMINERR
#define SRV_ENO_OOB		59 + SRV_EMINERR
#define SRV_ESIGURG_SETUP	60 + SRV_EMINERR
#define SRV_ENOTSITE		61 + SRV_EMINERR
#define SRV_EBADCONFIGOPT	62 + SRV_EMINERR
#define SRV_EOBJSYNTAX		63 + SRV_EMINERR
#define SRV_ENETTERM		64 + SRV_EMINERR
#define SRV_EBADSTATUS		65 + SRV_EMINERR
#define SRV_ERETVALRPC		66 + SRV_EMINERR
#define SRV_EBADTYPELEN		67 + SRV_EMINERR
#define SRV_EPROCFREE		68 + SRV_EMINERR
#define SRV_EINVCHAN		69 + SRV_EMINERR
#define SRV_ENOLOGFILE		70 + SRV_EMINERR
#define SRV_ECOLNUMBER		71 + SRV_EMINERR 
#define SRV_EDUPITEM		72 + SRV_EMINERR
#define SRV_EINCDESC		73 + SRV_EMINERR
#define SRV_EMAXUEVENT		74 + SRV_EMINERR
#define SRV_EEVENTTYPE		75 + SRV_EMINERR
#define SRV_EINATTN		76 + SRV_EMINERR
#define SRV_EINCONNECT		77 + SRV_EMINERR 
#define SRV_EBLOCKREAD		78 + SRV_EMINERR
#define SRV_ESIGIO		79 + SRV_EMINERR
#define SRV_EDEFQFULL		80 + SRV_EMINERR
#define SRV_EFLAGIGN		81 + SRV_EMINERR
#define SRV_ESIGSUPERCEDE	82 + SRV_EMINERR
#define	SRV_EDEFUNUSED		83 + SRV_EMINERR
#define	SRV_EBADPROCTYPE	84 + SRV_EMINERR 
#define SRV_EDNAALLFAIL		85 + SRV_EMINERR
#define SRV_EDNACRELSNMBX	86 + SRV_EMINERR
#define SRV_EDNANETASSIGN	87 + SRV_EMINERR
#define SRV_EDNADUPOBJ		88 + SRV_EMINERR
#define SRV_EDNADECLARE		89 + SRV_EMINERR
#define SRV_EDNALISTEN		90 + SRV_EMINERR
#define SRV_EDNAASSIGN		91 + SRV_EMINERR
#define SRV_EDNAACCESS		92 + SRV_EMINERR
#define SRV_EDNANOLINK		93 + SRV_EMINERR
#define SRV_ENOTSERVICE		94 + SRV_EMINERR
#define SRV_EEVENTNOSERVICE	95 + SRV_EMINERR
#define SRV_EDEFHANDLER		96 + SRV_EMINERR
#define SRV_ERPCINCONSIST	97 + SRV_EMINERR
#define SRV_ECHANSETUP		98 + SRV_EMINERR 
#define SRV_ENOSCHEDPROC 	99 + SRV_EMINERR
#define SRV_EDEFERFAIL 		100 + SRV_EMINERR
#define SRV_EDEFERINVMSG 	101 + SRV_EMINERR
#define SRV_EINVEVENT	 	102 + SRV_EMINERR
#define SRV_EINVSTACK	 	103 + SRV_EMINERR
#define SRV_ESTACKALLOC 	104 + SRV_EMINERR
#define SRV_EINVPRIORITY 	105 + SRV_EMINERR
#define SRV_EALLOCFAIL		106 + SRV_EMINERR
#define SRV_ENOPRACK		107 + SRV_EMINERR
#define SRV_ENULLPARAM		108 + SRV_EMINERR
#define SRV_EPMSTAT		109 + SRV_EMINERR
#define SRV_EBADPARAM		110 + SRV_EMINERR
#define SRV_EPNOTCLIENT		111 + SRV_EMINERR
#define SRV_EOBJNAME		112 + SRV_EMINERR
#define SRV_EOBJID		113 + SRV_EMINERR
#define SRV_ELOCKMODE		114 + SRV_EMINERR
#define SRV_ENOSPAWN		115 + SRV_EMINERR
#define SRV_EINRESTART		116 + SRV_EMINERR
#define SRV_EINSTOP		117 + SRV_EMINERR
#define SRV_ENOTOWNER		118 + SRV_EMINERR
#define SRV_EPRNUM		119 + SRV_EMINERR
#define SRV_EPARAMNAME		120 + SRV_EMINERR
#define SRV_EPTYPE		121 + SRV_EMINERR
#define SRV_EPUNREGNOPROC	122 + SRV_EMINERR
#define SRV_EPROCNOTREG		123 + SRV_EMINERR
#define SRV_EPEXISTS		124 + SRV_EMINERR
#define	SRV_EPNOPROC		125 + SRV_EMINERR
#define	SRV_EPNONOTICEREQ	126 + SRV_EMINERR
#define SRV_EPNOSRVPROC		127 + SRV_EMINERR
#define SRV_EBUFFSIZE		128 + SRV_EMINERR
#define SRV_EPNOPROCEX		129 + SRV_EMINERR
#define SRV_ENEEDPARAM		130 + SRV_EMINERR
#define SRV_EUNKNOWNPARAM	131 + SRV_EMINERR
#define SRV_ENOLANG		132 + SRV_EMINERR
#define SRV_EMAXCONNECT		133 + SRV_EMINERR
#define SRV_EPCALLBACK		134 + SRV_EMINERR
#define SRV_EMAXPARAM		135 + SRV_EMINERR
#define SRV_EBADFLAG		136 + SRV_EMINERR
#define SRV_EMAXREMSITES	137 + SRV_EMINERR
#define SRV_EPNOTIFYEXISTS	138 + SRV_EMINERR
#define SRV_EMAXREMCONNS	139 + SRV_EMINERR
#define SRV_EMAXRPC		140 + SRV_EMINERR
#define SRV_EPROCNULL		141 + SRV_EMINERR
#define SRV_EPROCINVALID	142 + SRV_EMINERR
#define SRV_EPROCBOUND		143 + SRV_EMINERR
#define SRV_EPROCNOTUSED	144 + SRV_EMINERR
#define SRV_EPROCIODEAD		145 + SRV_EMINERR
#define SRV_ECONSRVFAIL		146 + SRV_EMINERR
#define SRV_ENONETBUF		147 + SRV_EMINERR
#define SRV_ENOTSUPPORTED	148 + SRV_EMINERR
#define SRV_ECORRUPT		149 + SRV_EMINERR
#define SRV_ELOWSTK		150 + SRV_EMINERR
#define SRV_EBADSTK		151 + SRV_EMINERR
#define	SRV_EIO			152 + SRV_EMINERR
#define	SRV_EDISC		153 + SRV_EMINERR
#define	SRV_ENETCLOSE		154 + SRV_EMINERR
#define	SRV_ENODEV		155 + SRV_EMINERR
#define	SRV_ECMD		156 + SRV_EMINERR
#define	SRV_ETYPE		157 + SRV_EMINERR
#define	SRV_EBADCOUNT		158 + SRV_EMINERR
#define	SRV_EBADSTAT		159 + SRV_EMINERR
#define	SRV_EBADFORMAT		160 + SRV_EMINERR
#define	SRV_ENOMSG		161 + SRV_EMINERR
#define SRV_ENOBIND		162 + SRV_EMINERR
#define	SRV_ETRUNC		163 + SRV_EMINERR
#define	SRV_ENULLADDR		164 + SRV_EMINERR
#define	SRV_ESTATE		165 + SRV_EMINERR
#define	SRV_ELEN		166 + SRV_EMINERR
#define	SRV_EDUPROW		167 + SRV_EMINERR
#define	SRV_ENOROW		168 + SRV_EMINERR
#define	SRV_ENOAGG		169 + SRV_EMINERR
#define	SRV_EDUPTAB		170 + SRV_EMINERR
#define	SRV_ENOTAB		171 + SRV_EMINERR
#define	SRV_EBADROW		172 + SRV_EMINERR
#define	SRV_EBADCOMPUTEBY	173 + SRV_EMINERR
#define	SRV_ENOCOMPUTEBY	174 + SRV_EMINERR
#define	SRV_EBADNUMBYLIST	175 + SRV_EMINERR
#define	SRV_ENOORDERBY		176 + SRV_EMINERR
#define	SRV_EBADNUMCOLS		177 + SRV_EMINERR
#define	SRV_EBADTABNUM		178 + SRV_EMINERR
#define	SRV_EBADNAMELEN		179 + SRV_EMINERR
#define	SRV_EBADCTRLLEN		180 + SRV_EMINERR
#define	SRV_ENULLNAME		181 + SRV_EMINERR
#define	SRV_EBADTABCOL		182 + SRV_EMINERR
#define	SRV_EUNSUPPORTED	183 + SRV_EMINERR
#define	SRV_ENOCHARSET		184 + SRV_EMINERR
#define	SRV_ECSRFILE		185 + SRV_EMINERR
#define	SRV_ECHARATTR		186 + SRV_EMINERR
#define	SRV_ENOTHEX		187 + SRV_EMINERR
#define	SRV_EARG		188 + SRV_EMINERR
#define	SRV_ECSNOCVT		189 + SRV_EMINERR
#define	SRV_ECSCVT		190 + SRV_EMINERR
#define	SRV_ENORETURN		191 + SRV_EMINERR
#define	SRV_ECSLOGREC		192 + SRV_EMINERR
#define	SRV_ECSMISMATCH		193 + SRV_EMINERR
#define	SRV_ECSLOAD		194 + SRV_EMINERR
#define	SRV_EBADNULL		195 + SRV_EMINERR
#define	SRV_ECHCONFIG		196 + SRV_EMINERR
#define	SRV_ELATEORDER		197 + SRV_EMINERR
#define	SRV_EBADITEM		198 + SRV_EMINERR
#define	SRV_ENOTINBULK		199 + SRV_EMINERR
#define	SRV_EBADIOTYPE		200 + SRV_EMINERR
#define	SRV_EGTONECOL		201 + SRV_EMINERR
#define	SRV_ENONELEFT		202 + SRV_EMINERR
#define	SRV_EWRONGTYPE		203 + SRV_EMINERR
#define	SRV_EBADNUMVAL		204 + SRV_EMINERR
#define	SRV_EDUPPARAM		205 + SRV_EMINERR
#define	SRV_ERPCINC		206 + SRV_EMINERR
#define	SRV_EBADROWLEN		207 + SRV_EMINERR
#define	SRV_EBADALTCOLTYPE	208 + SRV_EMINERR
#define	SRV_EIOTYPENOTSET	209 + SRV_EMINERR
#define	SRV_EBOUND		210 + SRV_EMINERR
#define	SRV_ETXTLENREAD		211 + SRV_EMINERR
#define	SRV_ETXTLENNOTREAD	212 + SRV_EMINERR
#define	SRV_ENOTIMESTAMP	213 + SRV_EMINERR
#define	SRV_ECSFALLBACK		214 + SRV_EMINERR
#define	SRV_ELOGINLEN		215 + SRV_EMINERR
#define	SRV_EBADCOLTYPE		216 + SRV_EMINERR
#define	SRV_ENEEDROW		217 + SRV_EMINERR
#define	SRV_ENEEDHANDLE		218 + SRV_EMINERR
#define	SRV_EINTERRUPTED	219 + SRV_EMINERR
#define	SRV_ESTATUS		220 + SRV_EMINERR
#define	SRV_EFLUSH		221 + SRV_EMINERR
#define	SRV_EFLUSHCON		222 + SRV_EMINERR
#define	SRV_EMORE		223 + SRV_EMINERR
#define	SRV_EMORECON		224 + SRV_EMINERR
#define	SRV_ECONTEXT		225 + SRV_EMINERR
#define	SRV_EVERSION		226 + SRV_EMINERR
#define	SRV_EBADTDS		227 + SRV_EMINERR
#define	SRV_EINOPTION		228 + SRV_EMINERR
#define	SRV_EWRONGTDSVER	229 + SRV_EMINERR
#define	SRV_EWRONGOPTCMD	230 + SRV_EMINERR
#define	SRV_EWRONGOPT		231 + SRV_EMINERR
#define	SRV_ENODATA   		232 + SRV_EMINERR
#define	SRV_ENULLARG		233 + SRV_EMINERR
#define SRV_EINUSEREVENT	234 + SRV_EMINERR
#define SRV_EBINDARG		235 + SRV_EMINERR
#define	SRV_ESTATECHK		236 + SRV_EMINERR
#define	SRV_ENOVERSION		237 + SRV_EMINERR
#define	SRV_EBADRESULT		238 + SRV_EMINERR
#define	SRV_ECONFAIL		239 + SRV_EMINERR
#define	SRV_ENETFUNC		240 + SRV_EMINERR
#define	SRV_EPROCFAIL		241 + SRV_EMINERR
#define	SRV_ECLOSEFAIL		242 + SRV_EMINERR
#define	SRV_EREADFAIL		243 + SRV_EMINERR
#define	SRV_EWRITEFAIL		244 + SRV_EMINERR
#define	SRV_EBLOCK		245 + SRV_EMINERR
#define	SRV_EUNBLOCK		246 + SRV_EMINERR
#define	SRV_ECHANNEL		247 + SRV_EMINERR
#define	SRV_EPOLL		248 + SRV_EMINERR
#define	SRV_EGLOBAL		249 + SRV_EMINERR
#define	SRV_EIOPOST		250 + SRV_EMINERR
#define	SRV_EBADLENARG		251 + SRV_EMINERR
#define	SRV_EPROCPROPS		252 + SRV_EMINERR
#define	SRV_EINSERVTHREAD	253 + SRV_EMINERR
#define SRV_EFROMDISCONNECT	254 + SRV_EMINERR
#define	SRV_ESMALLBUF		255 + SRV_EMINERR
#define	SRV_ELARGEBUF		256 + SRV_EMINERR
#define SRV_EFROMCONNECT	257 + SRV_EMINERR
#define SRV_EWRONGTDSSET	258 + SRV_EMINERR
#define SRV_EWRONGLANG		259 + SRV_EMINERR
#define SRV_ENOPROPSET		260 + SRV_EMINERR
#define	SRV_ESRVPROPS		261 + SRV_EMINERR
#define	SRV_EPROPCFG		262 + SRV_EMINERR
#define	SRV_EBADINTPROP 	263 + SRV_EMINERR
#define	SRV_ECAPMASK		264 + SRV_EMINERR
#define	SRV_EPROPNOSUPPORT 	265 + SRV_EMINERR
#define	SRV_ENOPROPCLEAR	266 + SRV_EMINERR
#define	SRV_ENOPROPTDS		267 + SRV_EMINERR
#define	SRV_ENOSERVNAME		268 + SRV_EMINERR
#define	SRV_ENOFDONE		269 + SRV_EMINERR
#define	SRV_EERROR		270 + SRV_EMINERR
#define	SRV_EENVDB		271 + SRV_EMINERR
#define	SRV_EENVLANG		272 + SRV_EMINERR
#define	SRV_EENVCHAR		273 + SRV_EMINERR
#define	SRV_ENOCUR		274 + SRV_EMINERR
#define	SRV_ENOCUREVENT		275 + SRV_EMINERR
#define	SRV_ENOCURPARAMS	276 + SRV_EMINERR
#define	SRV_ENOCURPARAM		277 + SRV_EMINERR
#define	SRV_ENOCURUPCOLS	278 + SRV_EMINERR
#define	SRV_ENOCURUPCOL		279 + SRV_EMINERR
#define	SRV_EDUPCUR		280 + SRV_EMINERR
#define	SRV_EBADCUR		281 + SRV_EMINERR
#define	SRV_ENOCURROWDESC	282 + SRV_EMINERR
#define	SRV_EROWCNT		283 + SRV_EMINERR
#define	SRV_ENOCURSENT		284 + SRV_EMINERR
#define	SRV_ECURSENT		285 + SRV_EMINERR
#define	SRV_ENOSENDCUR		286 + SRV_EMINERR
#define	SRV_ENOKEY		287 + SRV_EMINERR
#define	SRV_ENOKEYCOL		288 + SRV_EMINERR
#define	SRV_ENODYN		289 + SRV_EMINERR
#define	SRV_ENODYNEVENT		290 + SRV_EMINERR
#define	SRV_ENODYNPARAMS	291 + SRV_EMINERR
#define	SRV_ENODYNPARAM		292 + SRV_EMINERR
#define	SRV_EDUPDYN		293 + SRV_EMINERR
#define	SRV_EDYNINC		294 + SRV_EMINERR
#define	SRV_ENOSENDDYN		295 + SRV_EMINERR
#define	SRV_ENODYNSENT		296 + SRV_EMINERR
#define	SRV_EDYNSENT		297 + SRV_EMINERR
#define	SRV_EBADCTXT		298 + SRV_EMINERR
#define	SRV_EBADRESP		299 + SRV_EMINERR
#define	SRV_EBADTOKEN		300 + SRV_EMINERR
#define	SRV_ENOCONN		301 + SRV_EMINERR
#define	SRV_EDUPCURID		302 + SRV_EMINERR
#define	SRV_ETEXTLEFT		303 + SRV_EMINERR
#define	SRV_EBADALTID		304 + SRV_EMINERR
#define	SRV_ENOTXTSENT		305 + SRV_EMINERR
#define	SRV_ENOTEXTPTR		306 + SRV_EMINERR
#define	SRV_ENOPARAMRPC		307 + SRV_EMINERR
#define	SRV_ECAPABILITY		308 + SRV_EMINERR
#define	SRV_ECAPTYPE		309 + SRV_EMINERR
#define	SRV_EBADIO		310 + SRV_EMINERR
#define SRV_EBADMSGID		311 + SRV_EMINERR
#define SRV_ENOPARAMMSG		312 + SRV_EMINERR
#define SRV_ENOPARAMNUM		313 + SRV_EMINERR
#define	SRV_EPARAMINC		314 + SRV_EMINERR
#define	SRV_EPROTERR		315 + SRV_EMINERR
#define SRV_ENOPARAMEED		316 + SRV_EMINERR
#define SRV_ENODYNDESC		317 + SRV_EMINERR
#define SRV_ETXTLEFT		318 + SRV_EMINERR
#define SRV_EBLKINIT		319 + SRV_EMINERR
#define SRV_ENONATLOCALE	320 + SRV_EMINERR
#define SRV_EBADLOCALE		321 + SRV_EMINERR
#define SRV_ENOLOCALE		322 + SRV_EMINERR
#define SRV_ENOCHARLOCALE	323 + SRV_EMINERR
#define SRV_EWRONGNULL          324 + SRV_EMINERR
#define SRV_ENOINIT          	325 + SRV_EMINERR
#define	SRV_EWRONGARGLEN	326 + SRV_EMINERR
#define	SRV_ENONEGPWD		327 + SRV_EMINERR
#define	SRV_EREADFAILED		328 + SRV_EMINERR
#define	SRV_EWRONGMSG		329 + SRV_EMINERR
#define SRV_EINCPASSTHRU        330 + SRV_EMINERR
#define	SRV_ERECURSIVE		331 + SRV_EMINERR
#define SRV_ENORESCAP		332 + SRV_EMINERR
#define SRV_EINSTART		333 + SRV_EMINERR
#define SRV_ESTARTEVENT		334 + SRV_EMINERR
#define	SRV_ENONULLIND		335 + SRV_EMINERR
#define SRV_EBADPREC		336 + SRV_EMINERR
#define	SRV_EBADSCALE		337 + SRV_EMINERR
#define SRV_ERUN		338 + SRV_EMINERR
#define SRV_ETAKECOROUTINE	339 + SRV_EMINERR
#define SRV_ERELEASECOROUTINE	340 + SRV_EMINERR
#define SRV_ETAKEMUTEX		341 + SRV_EMINERR
#define SRV_ERELEASEMUTEX	342 + SRV_EMINERR


/*
** These error numbers are only valid on VOS.  They are not generated on
** any other platform.
*/
#define	SRV_EMSGSENDREPLY	343 + SRV_EMINERR
#define	SRV_EFREEBUF		344 + SRV_EMINERR
#define	SRV_ENOREADBUFFERS	345 + SRV_EMINERR
#define	SRV_EDEADCLIENT		346 + SRV_EMINERR
#define	SRV_EMSGSKIPPED		347 + SRV_EMINERR
#define	SRV_ECLIENTACCEPT	348 + SRV_EMINERR
#define	SRV_ECLIENTDISCONNECT	349 + SRV_EMINERR
#define	SRV_EQUEUECREATE	350 + SRV_EMINERR
#define	SRV_ESETTINGFASTQ	351 + SRV_EMINERR

/*
** These error numbers are only valid on VMS.  They are not generated on
** any other platform.
*/
#define	SRV_ETCPALLFAIL		352 + SRV_EMINERR
#define	SRV_ETCPNETASSIGN	353 + SRV_EMINERR
#define	SRV_ETCPSETKEEP		354 + SRV_EMINERR
#define SRV_ETCPSETREUSE	355 + SRV_EMINERR
#define SRV_ETCPACCEPTW		356 + SRV_EMINERR
#define SRV_ETCPASSIGN		357 + SRV_EMINERR
#define SRV_ETCPNOLINK		358 + SRV_EMINERR
#define	SRV_ETCPATTNAST		359 + SRV_EMINERR

/*
** These error numbers are only valid on NT.  They are not generated on
** any other platform.
*/
#define	SRV_EWAITFAIL		360 + SRV_EMINERR
#define	SRV_ECREATEEVENT	361 + SRV_EMINERR
#define	SRV_ESETEVENT		362 + SRV_EMINERR
#define SRV_ESTARTCOROUTINE	363 + SRV_EMINERR
#define SRV_EENDCOROUTINE	364 + SRV_EMINERR
#define SRV_ECREATEMUTEX	365 + SRV_EMINERR
#define SRV_EDELETEMUTEX	366 + SRV_EMINERR

/*
** Some more generic error messages -- added after initial 10.0 release
*/
#define SRV_EBADMSGFIELD	367 + SRV_EMINERR
#define SRV_ENOMSGSENT		368 + SRV_EMINERR

#endif	/* __OSERROR_H__ */
