#########################################################
#		RESOURCE TEMPLATE
#
# This file contains a list of configuration attributes
# for Sybase Replication Server. This is the template for
# configuring a new Replication Server. DO NOT EDIT THIS FILE. 
# Copy the template to another file and edit that.
#
# Syntax of the resource file is:
#
#	product_name.attribute:value
#
# Attributes with a value of USE_DEFAULT will use the Sybase
# defaults for this platform.
#
# NOTES:	
#   Generic attributes are prefaced by "sybinit." The
#   only generic attributes are "release_directory" and "product."
#    
#########################################################


#########################################################
#	RELEASE LOCATION
#
sybinit.release_directory: /usr/u/sybase

# The product that you wish to configure.  Possible values are:
#	rs
#
sybinit.product: rs


#############################################################
# REPLICATION SERVER ATTRIBUTES
#

# is this a new Replication Server installaion
rs.new_config: yes


#############################################################
# ID SERVER INFORMATION
#
# name of the ID Server
rs.rs_idserver_name: id

# login that other Replication Servers will use to connect with
# the ID Server
rs.rs_idserver_user: USE_DEFAULT

# password for the ID Server user
rs.rs_idserver_pass: USE_DEFAULT

# is the ID Server the same as the Replication Server that is being
# installed
rs.rs_id_server_is_rs_server: yes

# The next two attributes should be set only when there are multiple
# ID Server domains

# first ID used for Replication Servers in this ID Server domain
rs.rs_start_rs_id: USE_DEFAULT

# first ID used for databases in this ID Server domain
rs.rs_start_db_id: USE_DEFAULT

#############################################################
# REPLICATION SERVER INFORMATION
#

# name for the Replication Server
rs.rs_name: rs

# sa login for this Replication Server
rs.rs_rs_sa_user: sa
 
# sa password for this Replication Server
rs.rs_rs_sa_pass: USE_DEFAULT

# will the Replication Server manage databases with primary data,
# submit asynchronous transactions, or serve as an intermediate
# site in an indirect route.
rs.rs_requires_ltm: no

# charset to be used by this Replication Server (and the RSSD LTM if needed)
rs.rs_charset: USE_DEFAULT

#############################################################
# REPLICATION SERVER SYSTEM DATABASE INFORMAITON
#

# name of the SQLServer that will manage the Replication Server's
# system database.
rs.rs_rssd_sqlsrvr: rssd

# name of the database where the Replication Server system tables
# will be stored.
rs.rs_rssd_db: USE_DEFAULT

# do you want Sybinit to create the system database
rs.rs_create_rssd: no

# sa login for the system SQL Server
rs.rs_rssd_sa_login: USE_DEFAULT

# sa password for the system SQL Server
rs.rs_rssd_sa_pass: 

# name of the primary user for the system database
rs.rs_rssd_prim_user: USE_DEFAULT

# password for the primary user for the system database
rs.rs_rssd_prim_pass: USE_DEFAULT

# name of the maintenance user for the system database
rs.rs_rssd_maint_user: USE_DEFAULT

# password for the maintenance user for the system database
rs.rs_rssd_maint_pass: USE_DEFAULT

# name of the Database Owner for the RSSD
rs.rs_rssd_dbo_user: USE_DEFAULT

# password for the database owner
rs.rs_rssd_dbo_pass: USE_DEFAULT 

#############################################################
# REPLICATION SERVER SYSTEM DATABASE DEVICE INFORMAITON
#

# size of the system database
rs.rs_rsdddb_size: 10

# size of the log for the system database
rs.rs_rssd_log_size:10

# name of the device on which the system database is to be created
rs.rs_rssd_db_device_name: dbdev

# do you want Sybinit to create this device for the system database
rs.rs_create_rssd_database_dev: no

# physical pathname of the device for the system database
rs.rs_rssd_db_device_path: /work/dev1

# size of the device for the system database
rs.rs_rssddb_device_size: 10

# name of the device on which the log for the system database is to 
# be created
rs.rs_rssd_log_device_name: logdev

# do you want Sybinit to create this device for the log for the system
# database
rs.rs_create_rssd_log_dev: no

# physical pathname of the device for the log for the system database
rs.rs_rssd_log_device_path: /work/dev2

# size of the device for the log for the system database
rs.rs_rssd_log_device_size:10


#############################################################
# DISK PARTITION INFORMATION
#

# full path name of a raw disk partition for the Replication Server
rs.rs_diskp_name: /work/dev3

# logical identifier name for the raw disk partition for the Replication
# Server
rs.rs_diskp_lname: part1

# the size, in megabytes, of the raw disk partition
rs.rs_diskp_size: 20

# the offset, in megabytes, at which the Replication Server should begin
# writing in the raw disk partition

rs.rs_diskp_vstart: 0

#############################################################
# REMOTE SITE CONNECTION INFORMATION
#

# the Replication Server login name that other Replication Servers
# will use to connect with this Replication Server
rs.rs_rs_user: USE_DEFAULT

# the password for the Replication Server login name
rs.rs_rs_pass: USE_DEFAULT

#############################################################
# SYSTEM DATABASE LOG TRANSFER MANAGER INFORMATION 
#

# the name of the log transfer manager for the Replication Server
rs.ltm_name: ltm

# the Replication Server login name that the log transfer manager
# will use when connecting to the Replication Server
rs.rs_ltm_rs_user: USE_DEFAULT

# the password for the login name for the log transfer manager
rs.rs_ltm_rs_pass: USE_DEFAULT

# the login name for the user who will start and shutdown the log
# transfer manager for the Replication Server system database
rs.rs_ltm_admin_user: USE_DEFAULT

# the password for the admin user
rs.rs_ltm_admin_pass: USE_DEFAULT

#############################################################
# ID SERVER INTERFACES INFORMATION 
#

# add ID Server to interfaces file?
rs.do_add_id_server: yes

# connect retry count; number of times client tries to connect
# to ID Server before giving up
rs.rs_id_server_connect_retry_count: USE_DEFAULT

# connect retry delay time (in seconds); amount of time client
# waits between each connection attempt
rs.rs_id_server_connect_retry_delay_time: USE_DEFAULT

# notes associated with ID Server interfaces file entry
rs.rs_id_server_notes: Default Sybase Configuration

# protocol for ID Server network listener
rs.rs_id_server_network_protocol_list: tcp

# name of host for ID Server
rs.rs_idserver_hostname: herbie

# port numbers for network listener
rs.rs_idserver_port: 5002

#############################################################
# REPLICATION SERVER INTERFACES INFORMATION 
#

# add Replication Server to interfaces file?
rs.do_add_replication_server: no

# connect retry count; number of times client tries to connect
# to Replication Server before giving up
rs.rs_rs_connect_retry_count: USE_DEFAULT

# connect retry delay time (in seconds); amount of time client
# waits between each connection attempt
rs.rs_rs_connect_retry_delay_time: USE_DEFAULT

# notes associated with Replication Server interfaces file entry
rs.rs_rs_notes: Default Sybase Configuration

# protocol for Replication Server network listener
rs.rs_rs_network_protocol_list: tcp

# name of host for Replication Server
rs.rs_rs_hostname:  herbie

# port numbers for network listener
rs.rs_rs_port: 5005

#############################################################
# LOG TRANSFER MANAGER INTERFACES INFORMATION 
#

# add Log Transfer Manager to interfaces file?
rs.do_add_ltm: no

# connect retry count; number of times client tries to connect
# to Log Transfer Manager before giving up
rs.rs_ltm_connect_retry_count: USE_DEFAULT

# connect retry delay time (in seconds); amount of time client
# waits between each connection attempt
rs.rs_ltm_connect_retry_delay_time: USE_DEFAULT

# notes associated with Log Transfer Manager interfaces file entry
rs.rs_ltm_notes: Default Sybase Configuration

# protocol for Log Transfer Manager network listener
rs.rs_ltm_network_protocol_list: tcp

# name of host for Log Transfer Manager
rs.rs_ltm_hostname:  herbie

# port numbers for network listener
rs.rs_ltm_port: 5000

# end of resource file
