#########################################################
#		RESOURCE TEMPLATE
#
# This file contains a list of configuration attributes
# for Sybase Replication Server. This is the template for
# adding a database to the replication system. DO NOT EDIT THIS FILE. 
# Copy the template to another file and edit that.
#
# Syntax of the resource file is:
#
#	product_name.attribute:value
#
# Attributes with a value of USE_DEFAULT will use the Sybase
# defaults for this platform.
#
# NOTES:	
#   Generic attributes are prefaced by "sybinit." The
#   only generic attributes are "release_directory" and "product."
#    
#########################################################


#########################################################
#	RELEASE LOCATION
#
sybinit.release_directory: /usr/u/sybase

# The product that you wish to configure.  Possible values are:
#	rs
#
sybinit.product: rs


#############################################################
# REPLICATION SERVER ATTRIBUTES
#

# is this a new Replication Server installaion
rs.new_config: no


#############################################################
# REPLICATION SERVER INFORMATION
#

# name for the Replication Server
rs.rs_name: rs

# sa login for this Replication Server
rs.rs_rs_sa_user: sa

# sa password for this Replication Server
rs.rs_rs_sa_pass: USE_DEFAULT

#############################################################
# DATABASE INFORMAITON
#

# name of the SQLServer with the database that you are adding to 
# the replicated data system
rs.rs_ds_name: sqls

# sa login for this SQL Server
rs.rs_ds_sa_user: USE_DEFAULT

# sa password for this SQL Server
rs.rs_ds_sa_password: 

# name of the database that you are adding to the replicated data system
rs.rs_db_name: master

# will this database hold primary data, or will asynchronous transactions
# originate in this database
rs.rs_requires_ltm: yes

# name of the user who will update replicated data 
rs.rs_db_maint_user: USE_DEFAULT

# password for this user who will update replicated data 
rs.rs_db_maint_password: USE_DEFAULT

# name of the Database Owner for this database
rs.rs_db_dbo_user: USE_DEFAULT

# password for the database owner
rs.rs_db_dbo_password: USE_DEFAULT 

#############################################################
# SYSTEM DATABASE LOG TRANSFER MANAGER INFORMATION 
#

# the name of the log transfer manager for the Replication Server
rs.ltm_name: ltm

# the Replication Server login name that the log transfer manager
# will use when connecting to the Replication Server
rs.rs_ltm_rs_user: USE_DEFAULT

# the password for the login name for the log transfer manager
rs.rs_ltm_rs_pass: USE_DEFAULT

# the login name for the user who will start and shutdown the log
# transfer manager for the Replication Server system database
rs.rs_ltm_admin_user: USE_DEFAULT

# the password for the admin user
rs.rs_ltm_admin_pass: USE_DEFAULT

# the charset used by the LTM
rs.rs_charset: USE_DEFAULT

#############################################################
# LOG TRANSFER MANAGER INTERFACES INFORMATION 
#

# add Log Transfer Manager to interfaces file?
rs.do_add_ltm: no

# connect retry count; number of times client tries to connect
# to Log Transfer Manager before giving up
rs.rs_ltm_connect_retry_count: USE_DEFAULT

# connect retry delay time (in seconds); amount of time client
# waits between each connection attempt
rs.rs_ltm_connect_retry_delay_time: USE_DEFAULT

# notes associated with Log Transfer Manager interfaces file entry
rs.rs_ltm_notes: Default Sybase Configuration

# protocol for Log Transfer Manager network listener
rs.rs_ltm_network_protocol_list: tcp

# name of host for Log Transfer Manager
rs.rs_ltm_hostname:  herbie

# port numbers for network listener
rs.rs_ltm_port: 5000

# end of resource file
