
#########################################################
#		RESOURCE TEMPLATE
#
# This file contains a list of configuration attributes
# for Sybase SQL Server. This is the template for
# configuring an existing SQL Server. DO NOT EDIT THIS FILE.
# Copy the template to another file and edit that.
#
# Syntax of the resource file is:
#
#	product_name.attribute:value
#
# NOTES:	
# Generic attributes are prefaced by "sybinit."  The only required
# generic attributes are "release_directory" and "product."
 
#########################################################

#########################################################
#	RELEASE LOCATION
#
# To upgrade the SQL Server just point sybinit.release_directory
# to the old release directory and point sqlsrv.server_name
# to the server to be upgraded -- sybinit will figure out
# where the new SQL Server is.

sybinit.release_directory: /put_your_491_release_directory_pathname_here

# The product that you wish to configure.
sybinit.product: sqlsrv

#############################################################
# SQL SERVER ATTRIBUTES

# name for SQL Server (default name is SYBASE)
sqlsrv.server_name: USE_DEFAULT

# If this is a newly installed product set this attribute to yes.
sqlsrv.new_config: no


#############################################################
# INFORMATION ABOUT THE SQL SERVER INTERFACES FILE ENTRY

# add SQL Server to interfaces file?
sqlsrv.do_add_server: no

# connect retry count; number of times client tries to connect
# to SQL Server before giving up
sqlsrv.connect_retry_count: 0

# connect retry delay time (in seconds); amount of time client
# waits between each connection attempt
sqlsrv.connect_retry_delay_time: 0

# notes associated with SQL Server interfaces file entry
sqlsrv.notes: 

# protocol for SQL Server network listener
sqlsrv.network_protocol_list: tcp

# alias name for SQL Server network listener
sqlsrv.network_name_alias_list: 

# name of host for SQL Server
sqlsrv.network_hostname_list: put_your_hostname_here

# port number for network listener
sqlsrv.network_port_list: put_your_port_number_here


#############################################################
# MASTER DEVICE FILE

# pathname of the master device
sqlsrv.master_device_physical_name: /put_your_master_device_pathname_here

# size of the master device in megabytes
sqlsrv.master_device_size: UNCHANGED

#############################################################
# ACCOUNT WITH SA AUTHORIZATION

# account with SA authorization (default is sa)
sqlsrv.sa_login: USE_DEFAULT

# password for account with SA authorization (default is NULL)
sqlsrv.sa_password: USE_DEFAULT

#############################################################
# BACKUP SERVER

# Backup Server for the SQL Server to use (default is SYB_BACKUP) 
sqlsrv.default_backup_server: USE_DEFAULT

#############################################################
# SQL SERVER FILES

# pathname of SQL Server errorlog file (default is <release_directory>/install/errorlog)
sqlsrv.errorlog: USE_DEFAULT

#############################################################
# UPGRADING SQL SERVER

# upgrade SQL Server?
sqlsrv.do_upgrade: yes

#############################################################
# LANGUAGE, CHARACTER SET AND SORT ORDER

# default language for SQL Server
sqlsrv.default_language: UNCHANGED

# list of languages to install in SQL Server
sqlsrv.language_install_list: 

# list of languages to remove from SQL Server
sqlsrv.language_remove_list: 

# default character set for SQL Server
sqlsrv.default_characterset: UNCHANGED

# list of character sets to install in SQL Server
sqlsrv.characterset_install_list: 

# list of character sets to remove from SQL Server
sqlsrv.characterset_remove_list: 

# sort order for SQL Server
sqlsrv.sort_order: UNCHANGED

#############################################################
# INSTALLING THE AUDITING DATABASE

sqlsrv.do_install_auditing: no
sqlsrv.auditing_db_size: USE_DEFAULT
sqlsrv.auditing_device_logical_name: USE_DEFAULT
sqlsrv.auditing_device_physical_name: /put_your_device_pathname_here
sqlsrv.auditing_device_size: USE_DEFAULT
sqlsrv.do_create_auditing_device: no

#############################################################
# SSPROC DB

sqlsrv.sybsystemprocs_db_size: USE_DEFAULT
sqlsrv.sybsystemprocs_device_logical_name: USE_DEFAULT
sqlsrv.sybsystemprocs_device_physical_name: /put_your_device_pathname_here
sqlsrv.sybsystemprocs_device_size: USE_DEFAULT
sqlsrv.do_create_sybsystemprocs_device: yes

# end of resource file
